   ' ****************************************************************
   ' ***  FFT09-02 *** POSITIVE FREQUENCY FFT ***
   'THIS PROGRAM ANALYZES TIME DOMAIN DATA WITH FRACTIONAL FREQUENCY
   'ANALYSIS.  IT SIMULATES THE PERFORMANCE REQUIRED FOR A FREQUENCY
   'ANALYZER AND INCLUDES THE LATEST PFFFT (FFT08-01).
   ' ****************************************************************
10 SCREEN 9, 1: COLOR 15, 1: CLS ' SETUP DISPLAY SCREEN
12 QX = 2 ^ 13: QI = 2 ^ 6: WSF = 1' MAX & NOM SIZE & S.F. CORR
14 N = 12: X0 = 50: Y0 = 10: ASF = 224: SCALE = 1
16 Q = 2 ^ N: N1 = N - 1: Q1 = Q - 1: Q2 = Q / 2: Q3 = Q2 - 1: Q4 = Q / 4
18 Q5 = Q4 - 1: Q8 = Q / 8: Q9 = Q8 - 1: Q34 = Q2 + Q4: Q16 = Q / 16
20 DIM Y(QX), C(QX), S(QX), KC(Q2), KS(Q2)
22 PI = 3.14159265358979#: P2 = PI * 2: K1 = P2 / Q
24 IOFLG = 2: WTFLG = 1 ' SET TO GRAPHIC DISPLAY AND NO WEIGHTING
26 XSF = 500 / Q2: KLOG = LOG(10): YSF = LOG(ASF) / KLOG: SK1 = 1
28 WEXP = 6: FRACF = 1
32 FOR I = 0 TO Q3: KC(I) = COS(I * K1): KS(I) = SIN(I * K1): NEXT I
34 GOSUB 900 ' SETUP SYSTEM
   '    ************************************************
   '    ********   MAIN MENU (ANALYZER SETUP)   ********
   '    ************************************************
40 CLS : LOCATE 2, 30: PRINT "ANALYZER SETUP MENU"
42 LOCATE 6, 1' DISPLAY MENU
60 PRINT SPC(5); "1 = ANALYZE 64 POINT ARRAY": PRINT
62 PRINT SPC(5); "2 = ANALYZE 128 POINT ARRAY": PRINT
64 PRINT SPC(5); "3 = ANALYZE 256 POINT ARRAY": PRINT
66 PRINT SPC(5); "4 = ANALYZE 512 POINT ARRAY": PRINT
68 PRINT SPC(5); "5 = ANALYZE 1024 POINT ARRAY": PRINT
70 PRINT SPC(5); "6 = ANALYZE 2048 POINT ARRAY": PRINT
72 PRINT SPC(5); "7 = ANALYZE 4096 POINT ARRAY": PRINT
73 PRINT SPC(5); "8 = CHANGE SYSTEM SETUP": PRINT
74 PRINT SPC(5); "9 = END": PRINT
78 PRINT SPC(10); "MAKE SELECTION: ";
80 A$ = INKEY$: IF A$ = "" THEN 80
82 IF ASC(A$) < 49 OR ASC(A$) > 57 THEN PRINT A$; " = INVALID KEY": GOTO 42
90 A = VAL(A$): ON A GOSUB 850, 860, 865, 870, 875, 880, 885, 900, 999
92 GOTO 40
94 RETURN
98  '         *****************************
100 '         ***   FORWARD TRANSFORM   ***
102 '         *****************************
106 '          ***  TRANSFORM STAGE 1  ***
108 T9 = TIMER
110 C(0) = (S(0) + S(Q2)) / 2: C(1) = (S(0) - S(Q2)) / 2
112 FOR I = 1 TO Q3: I2 = 2 * I: INDX = 0 ' BIT REVERSE DATA ADDRESSES
114 FOR J = 0 TO N1: IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N - 2 - J)
116 NEXT J
118 C(I2) = (S(INDX) + S(INDX + Q2)) / 2: C(I2 + 1) = (S(INDX) - S(INDX + Q2)) / 2
120 NEXT I
122 FOR I = 0 TO Q1: S(I) = 0: NEXT I
'       *********  REMAINING STAGES  **********
124 FOR M = 1 TO N1: QP = 2 ^ M: QPI = 2 ^ (N1 - M)
126  FOR K = 0 TO QPI - 1
128   FOR J = 0 TO QP / 2: J0 = J + (2 * K * QP): J1 = J0 + QP: K2 = QPI * J
130   JI = J1 - (2 * J)
132   CTEMP1 = C(J0) + C(J1) * KC(K2) - S(J1) * KS(K2)
134   STEMP1 = S(J0) + C(J1) * KS(K2) + S(J1) * KC(K2)
136   CTEMP2 = C(J0) - C(J1) * KC(K2) + S(J1) * KS(K2)
138   S(JI) = (C(J1) * KS(K2) + S(J1) * KC(K2) - S(J0)) / 2
140   C(J0) = CTEMP1 / 2: S(J0) = STEMP1 / 2: C(JI) = CTEMP2 / 2
142   NEXT J
144  NEXT K
146 NEXT M
148 FOR J = Q2 + 1 TO Q1: C(J) = 0: S(J) = 0: NEXT J
150 T9 = TIMER - T9
152 ON IOFLG GOSUB 300, 350 ' DISPLAY SPECTRUM
RETURN

'         ********************************
'         *******   PRINT OUTPUT   *******
300 '     ********************************
160 FOR Z = 0 TO Q5' PRINT OUTPUT
162 PRINT USING "####"; Z; : PRINT "   ";
164 PRINT USING "+##.#####"; SK1 * C(Z); : PRINT "   ";
166 PRINT USING "+##.#####"; SK1 * S(Z); : PRINT "     ";
168 PRINT USING "####"; Z + Q4; : PRINT "   ";
170 PRINT USING "+##.#####"; SK1 * C(Z + Q4); : PRINT "   ";
172 PRINT USING "+##.#####"; SK1 * S(Z + Q4)
174 NEXT Z
176 PRINT "T = "; T9: INPUT "ENTER TO CONTINUE"; A$
178 RETURN
    ' **********************************
    ' *         PLOT SPECTRUM          *
    ' **********************************
350 CLS : LINE (X0 - 1, 11)-(X0 - 1, Y0 + 320)' DRAW Y AXIS
352 LINE (X0, Y0 + 1)-(X0 + 500, Y0 + 1)' DRAW X AXIS
    '      **** DRAW 20 DB LINES ****
354 FOR I = 2 TO 14 STEP 2: YSKT = INT(YSF * 10 * LOG(1 / (10 ^ I)) / KLOG)
356 LINE (X0, Y0 - YSKT)-(X0 + 500, Y0 - YSKT)
358 YDB = CINT(.4 + (Y0 - YSKT) / 15.666): IF YDB > 25 THEN 362
360 LOCATE YDB, 2: PRINT USING "###."; 10 * I; ': PRINT (.4 + (Y0 - YSKT) / 1);
'INPUT A$
362 NEXT I
364 YP = SCALE * SQR(C(I) ^ 2 + S(I) ^ 2)   '  FIND RSS OF DATA POINT
366 IF YP = 0 THEN YP = -160: GOTO 370' OUT OF RANGE, SKIP
368 YP = 20 * LOG(YP) / KLOG' FIND DB VALUE
370 LINE (X0, Y0 - (YSF * YP))-(X0, Y0 - (YSF * YP))' SET PEN TO ORIGIN
372 FOR I = 0 TO Q3 ' *******    PLOT DATA POINTS    *******
374 YP = SCALE * SQR(C(I) ^ 2 + S(I) ^ 2)   '  FIND RSS OF DATA POINT
380 IF YP = 0 THEN YP = -160: GOTO 384' OUT OF RANGE, SKIP
382 YP = 20 * LOG(YP) / KLOG' FIND DB VALUE
384 LINE -(X0 + XSF * I, Y0 - YSF * YP)' DRAW LINE
386 NEXT I
388 LOCATE 1, 70: PRINT "F = "; : PRINT USING "###.#"; F8
RETURN

    ' **********************************
    ' *      GENERATE SINE WAVE        *
    ' **********************************
400 FOR I = 0 TO QDT: C(I) = 0: S(I) = SIN(F9 * K1 * I): NEXT
402 FOR I = QDT TO Q: C(I) = 0: S(I) = 0: NEXT
404 IF FLG80 = 1 THEN GOSUB 410
406 IF WTFLG = 2 THEN 450
408 RETURN
410 FOR I = 0 TO QDT: S(I) = S(I) + .0001 * SIN(2 * F9 * K1 * I): NEXT
412 RETURN
450 ' ****  WEIGHTING FUNCTION  ***
452 FOR I = 0 TO QDT
454 S(I) = S(I) * (SIN(I * PI / QDT) ^ WEXP)
456 NEXT I
458 RETURN

'     **********************************
600 ' ***     SPECTRUM ANALYZER      ***
    ' **********************************
602 CLS : PRINT : PRINT
604 PRINT SPC(20); "PREPARING DATA - PLEASE WAIT"
610 GOSUB 400 ' GENERATE SINUSOID
620 GOSUB 100 ' ANALYZE SPECTRUM
624 REPT = 0  ' RESET REPEAT FLAG
626 LOCATE 24, 65: PRINT "RETURN TO EXIT";
628 A$ = INKEY$: IF A$ = "" THEN 628' WAIT USER INPUT
630 IF ASC(A$) = 0 THEN GOSUB 650' CURSOR HAS LEADING ZERO
632 IF REPT = 1 THEN 620 ' ANALYZE SPECTRUM AGAIN
634 RETURN ' BACK TO MAIN MENU

650 ' ***  HANDLE CURSOR KEYS  ***
652 A = ASC(RIGHT$(A$, 1)) ' WHICH CURSOR
654 IF A < 75 OR A > 77 OR A = 76 THEN 669 ' NOT A CURSOR KEY
656 IF A = 75 THEN F8 = F8 - .1 ' INC FREQUENCY
658 IF A = 77 THEN F8 = F8 + .1 ' DEC. FREQUENCY
660 F9 = F8 * Q / QI' SCALE FOR CURRENT ARRAY SIZE
662 GOSUB 400 ' GENERATE NEW SINUSOID
664 REPT = 1 ' SET REPEAT FLAG
669 RETURN ' DO IT AGAIN SAM

800 ' *********************************************
    ' *    SETUP FRACTIONAL FREQUENCY ANALYZER    *
    ' *********************************************
850 N = 6: N1 = 5: Q = 2 ^ N ' SET ARRAY SIZE
852 QI = Q / FRACF: Q2 = Q / 2: Q3 = Q2 - 1: Q4 = Q / 4: Q5 = Q4 - 1
853 Q8 = Q / 8: Q9 = Q8 - 1: Q16 = Q / 16: Q34 = Q2 + Q4
854 F8 = 16: F9 = F8 * Q / QI: K1 = P2 / Q
585 QDT = Q / FRACF - 1 ' NEW TWIDDLES NEXT LINE
856 FOR I = 0 TO Q3: KC(I) = COS(K1 * I): KS(I) = SIN(K1 * I): NEXT
857 XSF = 500 / Q2:  SCALE = WSF * FRACF * 2
858 GOSUB 600 ' ANALYZE SPECTRUM
859 RETURN ' BACK TO MAIN MENU

860 N = 7: N1 = 6: Q = 2 ^ N
862 GOTO 852

865 N = 8: N1 = 7: Q = 2 ^ N
867 GOTO 852

870 N = 9: N1 = 8: Q = 2 ^ N
872 GOTO 852

875 N = 10: N1 = 9: Q = 2 ^ N
877 GOTO 852

880 N = 11: N1 = 10: Q = 2 ^ N
882 GOTO 852

885 N = 12: N1 = 11: Q = 2 ^ N
887 GOTO 852


    '  ***********************
    '  *     SYSTEM SETUP    *
    '  ***********************
900 CLS : RTFLG = 1: PRINT SPC(20); "       SYSTEM SETUP MENU"
902 PRINT : LOCATE (5): PRINT "1 = DISPLAY "
904 PRINT : PRINT "2 = WEIGHTING FUNCTION"
906 PRINT : PRINT "3 = FRACTIONAL FREQUENCY"
907 PRINT : PRINT "4 = -80 DB COMPONENT"
908 PRINT : PRINT "5 = EXIT SETUP MENU"
910 A$ = INKEY$: IF A$ = "" THEN 910
912 A = ASC(A$): IF A < 49 OR A > 53 THEN 900
914 A = A - 48: ON A GOSUB 920, 930, 970, 988, 990
916 ON RTFLG GOTO 900, 928

920 CLS
922 PRINT "USE GRAPHIC DISPLAY (Y/N)";
924 A$ = INKEY$: IF A$ = "" THEN 924
926 IF A$ = "N" OR A$ = "n" THEN IOFLG = 1 ELSE IOFLG = 2
928 RETURN

930 CLS : PRINT "WEIGHTING FUNCTION ON (Y/N)";
932 A$ = INKEY$: IF A$ = "" THEN 932
934 IF A$ = "N" OR A$ = "n" THEN WTFLG = 1: WSF = 1: GOTO 956
936 WTFLG = 2: PRINT
938 PRINT "CHANGE WEIGHTING FUNCTION EXPONENT?"
940 A$ = INKEY$: IF A$ = "" THEN 940
942 IF A$ = "N" OR A$ = "n" THEN 952
944 PRINT "1 = SIN^2": PRINT "2 = SIN^4": PRINT "3 = SIN^6"
946 A$ = INKEY$: IF A$ = "" THEN 946
948 A = ASC(A$): IF A < 49 OR A > 51 THEN 946
950 A = A - 48: WEXP = 2 * A
952 WSF = 2: IF A = 2 THEN WSF = 8 / 3
954 IF A = 3 THEN WSF = 16 / 5
956 RETURN

970 CLS : PRINT : PRINT "SELECT FRACTIONAL FREQUENCY FOR ANALYSIS"
972 PRINT : PRINT "1 = 1/1"; SPC(20); "4 = 1/8"
974 PRINT "2 = 1/2"; SPC(20); "5 = 1/16"
976 PRINT "3 = 1/4"; SPC(20); "6 = 1/32"
978 A$ = INKEY$: IF A$ = "" THEN 978
980 A = ASC(A$): IF A < 49 OR A > 54 THEN 978
982 A = A - 49: FRACF = 2 ^ A
984 RETURN

988 FLG80 = 1 - FLG80: RETURN

990 RTFLG = 2: RETURN
    ' **********
999 END: STOP ' THAT'S ALL FOLKS

