'   *****************************************
'   *******  2DFFT 13.00 - 2D XFORM   *******
'   ******* APPS 2ND EDITION - 05/03  *******
'   *****************************************

10 SCREEN 9, 1, 1: COLOR 15, 1: CLS
14 INPUT "SELECT ARRAY SIZE AS 2^N.  N ="; N
16 N1 = N - 1: Q = 2 ^ N: Q1 = Q - 1
18 ' $DYNAMIC
20 DIM C(Q, Q), S(Q, Q), KC(Q), KS(Q), DAC(Q, Q), DAS(Q, Q)
30 Q2 = Q / 2: Q3 = Q2 - 1: Q4 = Q / 4: Q5 = Q4 - 1: Q8 = Q / 8
32 PI = 3.141592653589793#: PI2 = 2 * PI: K1 = PI2 / Q: CLVK = 1
 '  **** TWIDDLE FACTOR TABLE GENERATION ****
40 FOR I = 0 TO Q: KC(I) = COS(K1 * I): KS(I) = SIN(K1 * I)
42 IF ABS(KC(I)) < .0000005 THEN KC(I) = 0 ' CLEANUP TABLE
44 IF ABS(KS(I)) < .0000005 THEN KS(I) = 0
46 NEXT I
48 FOR I = 1 TO Q1: INDX = 0
50 FOR J = 0 TO N1
52 IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N1 - J)
54 NEXT J
56 IF INDX > I THEN SWAP KC(I), KC(INDX): SWAP KS(I), KS(INDX)
58 NEXT I

70 CLS : PRINT : PRINT : PRINT "               MAIN MENU": PRINT
74 PRINT " 1 = TRANSFORM FUNCTION": PRINT
76 PRINT " 2 = INVERSE TRANSFORM ": PRINT
84 PRINT " 3 = GENERATE FUNCTIONS              ": PRINT
88 PRINT " 4 = EXIT              ": PRINT : PRINT
90 PRINT "            MAKE SELECTION";
92 A$ = INKEY$: IF A$ = "" THEN 92
94 A = VAL(A$): ON A GOSUB 100, 150, 5000, 112
96 IF A = 4 THEN 9999
98 GOTO 70

 '  **********************************************
 '  *              XFORM FUNCTION                *
 '  **********************************************
100 CLS : K6 = -1: SK1 = 2: XDIR = 1: T9 = TIMER 'XDIR: 1 = FWD, 0 = INVERSE
102 GOSUB 200 ' DO FORWARD ROW XFORMS
104 GOSUB 300 ' DO FORWARD COLUMN XFORMS
106 T9 = TIMER - T9 ' CHECK TIME
108 'GOSUB 176 ' DISPLAY DATA
110 'PRINT : INPUT "ENTER TO CONTINUE"; A$ ' WAIT
112 RETURN

 '  **********************************************
 '  *            INVERSE TRANSFORM               *
 '  **********************************************
150 CLS : K6 = 1: SK1 = 1: XDIR = 0: T9 = TIMER
152 GOSUB 300 ' RECONSTRUCT COLUMNS
153 GOSUB 200 ' RECONSTRUCT ROWS
155 T9 = TIMER - T9 ' GET TIME
156 'GOSUB 176 ' PLOT OUTPUT
158 'PRINT : INPUT "ENTER TO CONTINUE"; A$ ' WAIT
160 RETURN

 '  **********************************************
 '  *                PLOT DATA                   *
 '  **********************************************
176 CLS : AMP1 = 0 ' FIND LARGEST MAGNITUDE IN ARRAY
178     FOR I = 0 TO Q - 1
180         FOR J = 0 TO Q - 1
182              IF XDIR = 0 THEN AMP = C(I, J): GOTO 186
184              AMP = SQR(C(I, J) ^ 2 + S(I, J) ^ 2)
186              IF AMP > AMP1 THEN AMP1 = AMP
188         NEXT J
190     NEXT I
192 MAG2 = -130 / AMP1 ' SET SCALE FACTOR
194 GOSUB 6000 ' PLOT 2-D DATA
196 LOCATE 1, 1: PRINT "TIME = "; T9
198 RETURN

 '  ************************************************
 '  *              TRANSFORMS                      *
 '  ************************************************
200 CLS : KRTST = 19
202 FOR KR = 0 TO Q1 ' XFORM 2D ARRAY BY ROWS
204 IF XDIR = 1 THEN GOSUB 400
206 PRINT USING "###_ "; KR; ' PRINT ROW BEING XFORMED
208 IF KR = KRTST THEN PRINT : KRTST = KRTST + 20' END PRINT LINE
'    ***********************************
'    * THE ROUTINE BELOW IS FOR A ROW  *
'    ***********************************
210 FOR M = 0 TO N1: QT = 2 ^ (N - M)' DO N STAGES
212 QT2 = QT / 2: QT3 = QT2 - 1: KT = 0
214 FOR J = 0 TO Q1 STEP QT: KT2 = KT + 1' DO ALL FREQUENCY SETS
216 FOR I = 0 TO QT3: J1 = I + J: K = J1 + QT2' DO ALL FREQUENCIES IN SET
    ' ROW BUTTERFLY
218 CTEMP = (C(KR, J1) + C(KR, K) * KC(KT) - K6 * S(KR, K) * KS(KT)) / SK1
220 STEMP = (S(KR, J1) + K6 * C(KR, K) * KS(KT) + S(KR, K) * KC(KT)) / SK1
222 CTEMP2 = (C(KR, J1) + C(KR, K) * KC(KT2) - K6 * S(KR, K) * KS(KT2)) / SK1
224 S(KR, K) = (S(KR, J1) + K6 * C(KR, K) * KS(KT2) + S(KR, K) * KC(KT2)) / SK1
226 C(KR, K) = CTEMP2: C(KR, J1) = CTEMP: S(KR, J1) = STEMP
228 NEXT I' ROTATE AND SUM NEXT PAIR OF COMPONENTS
230 KT = KT + 2
232 NEXT J' DO NEXT SET OF FREQUENCIES
234 NEXT M' DO NEXT STAGE
    ' BIT REVERSAL FOR ROW TRANSFORMS
236 FOR I = 1 TO Q1: INDX = 0
238 FOR J = 0 TO N1
240 IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N1 - J)
242 NEXT J
244 IF INDX > I THEN SWAP C(KR, I), C(KR, INDX): SWAP S(KR, I), S(KR, INDX)
246 NEXT I
248 IF XDIR = 0 THEN GOSUB 400
250 NEXT KR
252 T9 = TIMER - T9: GOSUB 176' USE TO SHOW RESULTS OF ROW XFORMS
254 A$ = INKEY$: IF A$ = "" THEN 254
256 CLS : T9 = TIMER - T9: RETURN' ROW TRANSFORMS DONE

'    *************************************
'    * THE ROUTINE BELOW IS FOR COLUMNS  *
'    *************************************
300 KRTST = 19
302 FOR KR = 0 TO Q1 ' XFORM 2D ARRAY BY COLUMNS
304 IF XDIR = 1 THEN GOSUB 410
306 PRINT USING "###_ "; KR;
308 IF KR = KRTST THEN PRINT : KRTST = KRTST + 20
310 FOR M = 0 TO N1: QT = 2 ^ (N - M)
312 QT2 = QT / 2: QT3 = QT2 - 1: KT = 0
314 FOR J = 0 TO Q1 STEP QT: KT2 = KT + 1
316 FOR I = 0 TO QT3:  J1 = I + J: K = J1 + QT2
    'COLUMN BUTTERFLYS
318 CTEMP = (C(J1, KR) + C(K, KR) * KC(KT) - K6 * S(K, KR) * KS(KT)) / SK1
320 STEMP = (S(J1, KR) + K6 * C(K, KR) * KS(KT) + S(K, KR) * KC(KT)) / SK1
322 CTEMP2 = (C(J1, KR) + C(K, KR) * KC(KT2) - K6 * S(K, KR) * KS(KT2)) / SK1
324 S(K, KR) = (S(J1, KR) + K6 * C(K, KR) * KS(KT2) + S(K, KR) * KC(KT2)) / SK1
326 C(K, KR) = CTEMP2: C(J1, KR) = CTEMP: S(J1, KR) = STEMP
328 NEXT I
330 KT = KT + 2
332 NEXT J
334 NEXT M
    'BIT REVERSAL FOR COLUMN TRANSFORMS
336 FOR I = 1 TO Q1: INDX = 0
338 FOR J = 0 TO N1
340 IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N1 - J)
342 NEXT J
344 IF INDX > I THEN SWAP C(I, KR), C(INDX, KR): SWAP S(I, KR), S(INDX, KR)
346 NEXT I
348 IF XDIR = 0 THEN GOSUB 410
350 NEXT KR
352 IF K6 = 1 THEN XDIR = 1
354 T9 = TIMER - T9: GOSUB 176' USE TO SHOW RESULTS OF COLUMN XFORMS
356 IF K6 = 1 THEN XDIR = 0
358 A$ = INKEY$: IF A$ = "" THEN 358
360 CLS : T9 = TIMER - T9: RETURN' COLUMN TRANSFORMS DONE


' ****************************************
' *         MODIFY ROW SAMPLING          *
' ****************************************
400 FOR I = 1 TO Q1 STEP 2
402 C(KR, I) = -C(KR, I): S(KR, I) = -S(KR, I)
404 NEXT I
406 RETURN
' ****************************************
' *        MODIFY COLUMN SAMPLING        *
' ****************************************
410 FOR I = 1 TO Q1 STEP 2
412 C(I, KR) = -C(I, KR): S(I, KR) = -S(I, KR)
414 NEXT I
416 RETURN

 '  ********************************************************
 '  *               PRINT OUTPUT
 '  ********************************************************
500 CLS : PRINT "ONLY DATA ABOUT THE 0,0 POINT WILL BE PRINTED"
' **************************************************
540 CLS ' PRINT SCREEN
542 FOR I = Q2 - 10 TO Q2 + 9
544 FOR ROLOC = Q2 - 8 TO Q2 + 7
546 Y2 = C(ROLOC, I): X2 = S(ROLOC, I)
548 MAG = SQR(Y2 ^ 2 + X2 ^ 2) / (4096) ': ANG = 180 / PI * ATN(X2 / Y2): IF Y2 < 0 THEN ANG = ANG + 180
550 PRINT USING "##._ "; MAG;
552 NEXT ROLOC
553 PRINT
554 NEXT I
556 INPUT A$
558 LINCTR = 0: RETURN



2400 ' *** MODIFY SPACE DOMAIN FUNCTION ***
2402 CLS : PRINT : PRINT SPC(15); "MENU"
2404 PRINT : PRINT "1 = CHANGE GREY SCALE RANGE"
2406 PRINT : PRINT "2 = MODIFY CONTRAST"
2408 A$ = INKEY$: IF A$ = "" THEN 2408
2410 ON VAL(A$) GOSUB 2420, 2460
2412 RETURN


' * LIMIT GREY SCALE RESOLUTION
2420 CLS
2422 A = 1: B = 0 ' FIRST FIND RANGE OF DATA
2424     FOR I = 0 TO Q - 1
2426          FOR J = 0 TO Q - 1
2428               IF C(I, J) > A THEN A = C(I, J)
2430               IF C(I, J) < B THEN B = C(I, J)
2432          NEXT J
2434     NEXT I
2436 IF B > 0 THEN B = 0 ' IF > 0 ELIMINATE FROM CALCS.
2438 INPUT "NUMBER OF BITS GREY SCALE (LESS THAN 16)"; GK
2440 GK = 2 ^ GK
2442 A = (A - B) / GK
2444     FOR I = 0 TO Q - 1
2446          FOR J = 0 TO Q - 1
2448               C(I, J) = INT((C(I, J) - B) / A)
2450          NEXT J
2452     NEXT I
2454 PRINT A, B' OKAY, NOW WE HAVE A NEW DYNAMIC RANGE
2456 RETURN
2460 ' * CHANGE CONTRAST *
2462 AMAX = 0: AMIN = 256
2464 FOR I = 0 TO Q - 1
2466 FOR J = 0 TO Q - 1
2468 A = C(I, J): IF A > AMAX THEN AMAX = A
2470 IF A < AMIN THEN AMIN = A
2472 NEXT J
2474 NEXT I
2475 C = 0: PRINT "AMAX ="; AMAX; " AND AMIN ="; AMIN
2476 PRINT "HOLD BLACK OR WHITE CONSTANT (B/W)?"
2478 A$ = INKEY$: IF A$ = "" THEN 2478
2480 IF A$ = "B" OR A$ = "b" THEN C = 1: GOTO 2484
2482 IF A$ <> "W" AND A$ <> "w" THEN 2478
2484 PRINT : INPUT "INPUT MULTIPLICATION FACTOR"; MK
2486 FOR I = 0 TO Q - 1
2488 FOR J = 0 TO Q - 1
2490 IF C = 0 THEN C(I, J) = AMAX - (MK * (AMAX - C(I, J)))
2492 IF C = 1 THEN C(I, J) = (MK * (C(I, J) - AMIN)) + AMIN
2494 NEXT J
2496 NEXT I
2498 GOSUB 6000 ' DISPLAY RESULTS
2500 INPUT A$ ' WAIT
2502 RETURN

' ********** SAVE PICTURE **********
'     FOR I = 0 TO Q - 1
'          FOR J = 0 TO Q - 1
'               STD(I, J) = C(I, J)
'          NEXT J
'     NEXT I
RETURN


' ********** RECALL PICTURE **********
'     FOR I = 0 TO Q - 1
'          FOR J = 0 TO Q - 1
'               C(I, J) = STD(I, J): S(I, J) = 0
'          NEXT J
'     NEXT I
RETURN

      '  *********************************
      '  *       MODIFY TRANSFORM        *
      '  *********************************
3000 CLS : PRINT : PRINT "MODIFY SPECTRUM MENU": PRINT : PRINT
3002 PRINT " 1 - MULTIPLY WITH STORED SPECTRUM"
3004 PRINT " 2 - DIVIDE CURRENT/STORED SPECTRUMS"
3006 PRINT " 3 - FILTER SPECTRUM"
3008 PRINT " 4 - TRUNCATE SPECTRUM"
3010 PRINT " 5 - SAVE SPECTRUM"
3014 PRINT " 9 - EXIT": PRINT : PRINT
3018 PRINT "   MAKE SELECTION"
3020 A$ = INKEY$: IF A$ = "" THEN 3020
3022 IF ASC(A$) < 49 OR ASC(A$) > 57 THEN 3000
3024 A = VAL(A$): ON A GOSUB 3200, 3300, 3100, 3500, 3400
3026 GOTO 3999

' **********************************
' *    GAUSSIAN FILTER
' **********************************
3100 INPUT "CUTOFF FREQ. "; FCO
3102 FOR I = -Q2 TO Q2
3104    FOR J = -Q2 TO Q2
3106       FI = SQR(I ^ 2 + J ^ 2): ATTN = (10 ^ (-.3 / 2 * (FI / FCO) ^ 3))
3108       I2 = Q2 + I: J2 = Q2 + J
3110       C(I2, J2) = C(I2, J2) * ATTN: S(I2, J2) = S(I2, J2) * ATTN
3112    NEXT J
3114 NEXT I
3116 GOSUB 6000 ' DISPLAY RESULTS
3118 INPUT A$ ' WAIT
3120 RETURN

3200 ' **** MULTIPLY FREQUENCY FUNCTIONS ****
3202 FOR I = 0 TO Q - 1
3204    FOR J = 0 TO Q - 1
3206       CIJ = C(I, J): SIJ = S(I, J)
3208       CDAT = DAC(I, J): SDAT = DAS(I, J)
3210       C(I, J) = (CIJ * CDAT) - (SIJ * SDAT): S(I, J) = (CIJ * SDAT) + (SIJ * CDAT)
3212    NEXT J
3214 NEXT I
3216 GOSUB 6000 ' DISPLAY RESULTS
3228 INPUT A$ ' WAIT
3230 RETURN

3300 CLS ' DIVIDE CURRENT/STORED SPECTRUM
3302 PRINT SPC(5); "C = DIVIDE CURRENT FUNCTION BY STORED FUNCTION"
3304 PRINT SPC(5); "S = DIVIDE STORED FUNCTION BY CURRENT FUNCTION"
3308 A$ = INKEY$: IF A$ = "" THEN 3308
3310 CSFLG = 1: IF A$ = "S" OR A$ = "s" THEN CSFLG = 2: GOTO 3314
3312 IF A$ <> "C" AND A$ <> "c" THEN 3308
3314 FOR I = 0 TO Q - 1
3316 FOR J = 0 TO Q - 1
3318 CIJ = C(I, J): SIJ = S(I, J): C(I, J) = 0: S(I, J) = 0
3320 RIJ = SQR(CIJ ^ 2 + SIJ ^ 2)
3322 ' IF RIJ < .0000001 THEN 3348 ' SKIP IF DATA TOO SMALL ?
3324 IF CIJ = 0 THEN PHIJ = PI / 2: GOTO 3328 ' CAN'T DIVIDE BY ZERO
3326 PHIJ = ATN(SIJ / CIJ) ' FIND ANGLE
3328 IF CIJ < 0 THEN PHIJ = PHIJ + PI ' CORRECT FOR NEG X AXIS
3330 CDAT = DAC(I, J): SDAT = DAS(I, J) ' GET STORED DATA
3332 RDAT = SQR(CDAT ^ 2 + SDAT ^ 2) ' FIND MAG
3334 IF CDAT = 0 THEN PHDAT = PI / 2: GOTO 3338 ' CAN'T DIVIDE BY ZERO
3336 PHDAT = ATN(SDAT / CDAT) ' GET ANGLE
3338 IF CDAT < 0 THEN PHDAT = PHDAT + PI ' CORRECT FOR NEG X  AXIS
3340 IF CSFLG = 1 THEN RQOT = RIJ / RDAT: PHQOT = PHIJ - PHDAT: GOTO 3344 ' DIVIDE (FINALLY)
3342 RQOT = RDAT / RIJ: PHQOT = PHDAT - PHIJ
3344 C(I, J) = COS(PHQOT) * RQOT ' CONVERT TO X,Y
3346 S(I, J) = SIN(PHQOT) * RQOT
3348 NEXT J
3350 NEXT I
3352 GOSUB 160 ' DISPLAY RESULTS
3354 INPUT A$ ' WAIT FOR USER
3390 RETURN

3400 ' ****  TEMP SAVE SPECTRUM IN DAX(I,J)  ****
3402 AMPN = 1
3404 FOR I = 0 TO Q - 1
3406    FOR J = 0 TO Q - 1
3408       DAC(I, J) = C(I, J): DAS(I, J) = S(I, J)
3410    NEXT J
3412 NEXT I
3414 RETURN

' ****  TRUNCATE SPECTRUM  ****
3500 ATTN = 0
3502 INPUT "TRUNCATE SPECTRUM ABOVE HARMONIC # "; HARX
3504 FOR I = 0 TO Q2
3506    FOR J = 0 TO Q2
3508        IF SQR(I ^ 2 + J ^ 2) < HARX THEN 3518
3510        GOSUB 3900
3518    NEXT J
3520 NEXT I
3522 GOSUB 6000 ' DISPLAY RESULTS
3524 INPUT A$ ' WAIT
3526 RETURN

3900 ' ****  MODIFY HARMONICS  ****
3902 I2 = Q2 + I: J2 = Q2 + J: I3 = Q2 - I: J3 = Q2 - J
3904 C(I2, J2) = C(I2, J2) * ATTN: S(I2, J2) = S(I2, J2) * ATTN
3906 C(I2, J3) = C(I2, J3) * ATTN: S(I2, J3) = S(I2, J3) * ATTN
3908 C(I3, J3) = C(I3, J3) * ATTN: S(I3, J3) = S(I3, J3) * ATTN
3910 C(I3, J2) = C(I3, J2) * ATTN: S(I3, J2) = S(I3, J2) * ATTN
3912 RETURN

3999 IF A = 9 THEN A = 8
RETURN

      '  *********************************
      '  *        LOAD .BMP FILE         *
      '  *********************************
4000 CLS : PRINT : PRINT : PRINT
4002 DMAX = 20: T1 = 0: T0 = 1: XDIR = 0: PATH$ = "A:\"
4004 REDIM IMAGE%(DMAX) ' *.BMP HEADER ARRAY
4006 INPUT "FILE NAME (.BMP FILES ONLY)"; NM$
4008 OPEN PATH$ + NM$ + ".BMP" FOR RANDOM AS #3 LEN = LEN(PIXREC)
4010 PRINT " LOF = "; LOF(3)
4012 FOR J = 1 TO 20 ' READ HEADER
4014 GET #3, J, PIXREC
4016 IMAG% = PIXREC.PIX
4018 IMAGE%(J) = IMAG%
4024 NEXT J
4026 IF IMAGE%(1) = 19778 AND IMAGE%(10) = Q THEN 4040 ' CHK .BMP & SIZE
4030 INPUT " THIS IS NOT A LEGAL .BMP FILE - ENTER TO CONTINUE"; A$
4032 CLOSE 3: GOTO 4090 ' CLOSE FILE & EXIT
4040 STRT = IMAGE%(6) / 2 + 1 ' GET DATA START LOCATION
4044 LINX = IMAGE%(10) ' NO. LINES
4046 COLX = IMAGE%(12) ' NO. COLS.
' LOAD FILE INTO DATA ARRAY
4048 FOR I = 0 TO Q - 1: KL1 = STRT + (LINX * I / 2) ' DATA LINE ADDRESS
4050 FOR J = 0 TO Q3 STEP 1: KL = KL1 + J: J2 = 2 * J ' DATA ADDRESS
4052 GET #3, KL, PIXREC
4054 IMAG% = PIXREC.PIX
4056 C(I, J2) = IMAG% AND 255: C(I, J2 + 1) = (IMAG% AND 65280) / 256
4058 S(I, J2) = 0: S(I, J2 + 1) = 0
4060 NEXT J
4062 NEXT I
4064 CLOSE 3
4066 MAG2 = -.025 ' SCALE FACTOR
4068 GOSUB 6000 ' DISPLAY IMAGE
4070 INPUT "PLOT AS A FUNCTION (Y/N)"; A$
4072 IF A$ = "Y" THEN GOSUB 160 ' DISPLAY FUNCTION
4074 INPUT "C/R WHEN READY"; A$ ' WAIT FOR USER
4090 RETURN

      '  *********************************
      '  *       SAVE *.BMP FILE         *
      '  *********************************
4100 CLS : PRINT : PRINT
4102 IF XDIR = 1 THEN GOSUB 50 ' TRANSFORM TO SPACE DOMAIN DATA FOR NOW
4104 A = 1: B = 0 ' FIRST BRING DATA BACK INTO RANGE, A=MAX, B=MIN
     FOR I = 0 TO Q - 1
          FOR J = 0 TO Q - 1
               IF C(I, J) > A THEN A = C(I, J)
               IF C(I, J) < B THEN B = C(I, J)
          NEXT J
     NEXT I
4118 IF B > 0 THEN B = 0 ' IF > 0 ELIMINATE FROM CALCULATIONS
4120 A = (A - B) / 255 ' FIND 0-255 SCALE FACTOR
4122 FOR I = 0 TO Q - 1 ' CONVERT TO 8 BIT DATA
          FOR J = 0 TO Q - 1
               C(I, J) = INT((C(I, J) - B) / A)
          NEXT J
     NEXT I
     FOR I = 0 TO 1: C(Q, I) = 0: C(I, Q) = 0: NEXT I
' PRINT A, B' OKAY, NOW WE CAN SAVE THE FILE
4134 PTH1$ = "C:\WINDOWS\D": PTH2$ = "C:\WINDOWS\": NM2$ = NM$
4136 IF LEN(NM2$) > 7 THEN NM2$ = LEFT$(NM2$, 7)
4138 OPEN PTH1$ + NM2$ + ".BMP" FOR RANDOM AS #3 LEN = LEN(PIXREC)
4140 OPEN PTH2$ + NM$ + ".BMP" FOR RANDOM AS #4 LEN = LEN(PIXREC)
4142 FOR I = 1 TO STRT - 1
4144 GET #4, I, PIXREC
4146 PUT #3, I, PIXREC
4148 NEXT I
4150 CLOSE #4
4152 PRINT "EXPAND FILE (Y/N)";
4154 A$ = INKEY$: IF A$ = "" THEN 4154
4156 IF A$ = "n" OR A$ = "N" THEN 4300
4158 PIXREC.PIX = INT(2 * Q)
4160 PUT #3, 10, PIXREC
4162 PUT #3, 12, PIXREC
4164 FOR I = 0 TO Q - 1: KS1 = (2 * I * Q) + STRT
4166 FOR J = 0 TO Q - 1: KS = KS1 + (J)
4168 PIXEL1 = C(I, J): PIXEL2 = (C(I, J + 1) + C(I, J)) / 2
4170 PIXEL = INT(PIXEL1) + 256 * INT(PIXEL2)
4172 IF PIXEL > 32767 THEN PIXEL = PIXEL - 65536
4174 PIXREC.PIX = INT(PIXEL)
4176 PUT #3, KS, PIXREC
4178 NEXT J
4180 KS1 = KS1 + Q
4182 FOR J = 0 TO Q - 1: KS = KS1 + J
4184 PIXEL1 = (C(I, J) + C(I + 1, J)) / 2: PIXEL2 = (C(I, J) + C(I + 1, J) + C(I, J + 1) + C(I + 1, J + 1)) / 4
4186 PIXEL = INT(PIXEL1) + 256 * INT(PIXEL2)
4188 IF PIXEL > 32767 THEN PIXEL = PIXEL - 65536
4190 PIXREC.PIX = INT(PIXEL)
4192 PUT #3, KS, PIXREC
4194 NEXT J
4196 NEXT I
4198 CLOSE #3
4200 RETURN

4300 ' STORE UNEXPANDED PICTURE
4302 FOR I = 0 TO Q - 1: KS1 = (I * Q / 2) + STRT
4304 FOR J = 0 TO Q - 1 STEP 2: KS = KS1 + (J / 2)
4306 PIXEL1 = C(I, J): PIXEL2 = C(I, J + 1)
4308 PIXEL = INT(PIXEL1) + 256 * INT(PIXEL2)
4310 IF PIXEL > 32767 THEN PIXEL = PIXEL - 65536
4312 PIXREC.PIX = INT(PIXEL)
4314 PUT #3, KS, PIXREC
4316 NEXT J
4318 NEXT I
4320 CLOSE #3
4322 RETURN



      '  *********************************
      '  *      GENERATE FUNCTIONS       *
      '  *********************************
5000 XDIR = 0
5001 CLS : PRINT : PRINT : PRINT "               FUNCTION MENU": PRINT
5002 PRINT " 1 = GENERATE SINC^2 FUNCTION      2 = SINC FUNCTION": PRINT
5008 PRINT " 9 = EXIT:": PRINT
5010 PRINT "            MAKE SELECTION";
5012 A$ = INKEY$: IF A$ = "" THEN 5012
5014 A = VAL(A$): ON A GOTO 5030, 5500
5016 IF A = 9 THEN RETURN
5018 GOTO 5000

      '  *********************************
      '  *       SINC^2 FUNCTION         *
      '  *********************************
5030 CLS : T1 = 0: T0 = 1
5032 INPUT "WIDTH"; WDTH1 ' INPUT FINCTION SIZE
5034 IF WDTH1 = 0 THEN WDTH1 = 1 ' ZERO INVALID
5036 SKL1 = PI2 / WDTH1: MAG1 = Q ' CALC CONSTANTS
5038 FOR I = 0 TO Q - 1 '
5040 YARG = SKL1 * (I - Q2): PRINT "*";
5042 FOR J = 0 TO Q - 1
5044 XARG = SKL1 * (J - Q2)
5046 IF YARG = 0 AND XARG = 0 THEN C(I, J) = MAG1: GOTO 5052
5048 ARG = SQR(XARG ^ 2 + YARG ^ 2)
5050 C(I, J) = MAG1 * (SIN(ARG) / ARG) ^ 2: S(I, J) = 0
5052 NEXT J
5054 NEXT I
5055 MAG2 = -130 / MAG1
5056 GOSUB 6000 ' PLOT FUNCTION
5058 INPUT A$ ' WAIT
5060 RETURN

5500  '  *********************************
      '  *         SINC FUNCTION         *
      '  *********************************
5502 CLS : MAG1 = Q: T0 = 1: T1 = 0
5504 INPUT "WIDTH"; WDTH1
5506 SKL1 = PI2 / WDTH1: MAG1 = Q
5508 FOR I = 0 TO Q - 1
5510 YARG = SKL1 * (I - Q2): PRINT "*";
5512 FOR J = 0 TO Q - 1
5514 XARG = SKL1 * (J - Q2)
5516 IF YARG = 0 AND XARG = 0 THEN C(I, J) = MAG1: GOTO 5590
5518 ARG = SQR(XARG ^ 2 + YARG ^ 2)
5520 C(I, J) = MAG1 * (SIN(ARG) / ARG): S(I, J) = 0
5590 NEXT J
5592 NEXT I
5594 GOSUB 176
5596 INPUT A$
5598 RETURN

6000  '  *******************************
      '  *         PLOT DATA           *
      '  *******************************
6002 CLS ' CLEAR SCREEN AND SET SCALE FACTORS
6004 XCAL = 320 / Q: YCAL = 120 / Q: YDIS = 150: X0 = 15
6006 FOR I = 0 TO Q - 1 ' FOR ALL ROWS
6008 DISP = X0 + (Q - I) * 288 / Q ' DISPLACE ROWS FOR 3/4 VIEW
6010 PER = I / (2 * Q) ' CORRECT FOR PERSPECTIVE
6012 FOR J = 0 TO Q - 1 ' FOR EACH PIXEL IN ROW
6014 X11 = ((XCAL + PER) * J) + DISP: Y11 = ((YCAL + .3 * PER) * I) + YDIS
6016 IF XDIR = 0 THEN AMP = C(I, J) ELSE AMP = SQR(C(I, J) ^ 2 + S(I, J) ^ 2)   ' CALC "Z" AXIS
6018 AMP = MAG2 * AMP
6020 LINE (X11, Y11 + AMP)-(X11, Y11)
6022 PRESET (X11, Y11 + AMP + 1)
6024 NEXT J ' NEXT PIXEL
6026 NEXT I ' NEXT ROW
6028 RETURN ' ALL DONE

9999 END: STOP

