   '    *** (FFT06.01) FFT/INV FFT ***
   '    THIS PROGRAM ILLUSTRATES GIBBS PHENOMENON/SPECTRUM TRUNCATION
10 ' DYNAMIC
12 SCREEN 9, 1: COLOR 15, 1
13 CLS : PRINT : PRINT "INPUT NUMBER OF DATA POINTS AS 2^N"
14 INPUT "N = "; N
16 Q = 2 ^ N: Q1 = Q - 1: N1 = N - 1
18 Q2 = Q / 2: Q3 = Q2 - 1: Q4 = Q / 4: Q5 = Q4 - 1: Q8 = Q / 8
20 DIM C(Q), S(Q), KC(Q), KS(Q), COMP(3, KB, 3), Z(2, KB, KB + 1)
22 X0 = 50: Y0 = 200: XSF = 500 / Q: YSF = 1024: IOFLG = 1
23 PI = 3.141592653589793#: P2 = 2 * PI: K1 = P2 / Q: PI2 = P2

24 '  **** TWIDDLE FACTOR TABLE GENERATION ****
26 FOR I = 0 TO Q: KC(I) = COS(K1 * I): KS(I) = SIN(K1 * I)
28 IF ABS(KC(I)) < .0000005 THEN KC(I) = 0 ' CLEAN UP TABLES
30 IF ABS(KS(I)) < .0000005 THEN KS(I) = 0
32 NEXT I
34 FOR I = 1 TO Q1: INDX = 0
36 FOR J = 0 TO N1
38 IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N1 - J)
40 NEXT J
42 IF INDX > I THEN SWAP KC(I), KC(INDX): SWAP KS(I), KS(INDX)
44 NEXT I
45 '  ****  PRINT MAIN MENU  ****
46 CLS
50 PRINT SPC(30); "MAIN MENU": PRINT : PRINT
52 PRINT SPC(5); "1 = GENERATE STEP FUNCTION & TRANSFORM": PRINT
54 PRINT SPC(5); "2 = FORWARD TRANSFORM": PRINT
56 PRINT SPC(5); "3 = MODIFY SPECTRUM": PRINT
58 PRINT SPC(5); "4 = INVERSE TRANSFORM": PRINT
60 PRINT SPC(5); "5 = MODIFY SYSTEM": PRINT
62 PRINT SPC(5); "6 = EXIT": PRINT
70 PRINT SPC(10); "MAKE SELECTION :";
80 A$ = INKEY$: IF A$ = "" THEN 80
90 A = VAL(A$): ON A GOSUB 600, 160, 1000, 170, 180, 990
95 GOTO 46

100 '     ****  FFT ROUTINE  ****
106 T9 = TIMER
110 REM *** FFT ROUTINE ***
112 FOR M = 0 TO N1: QT = 2 ^ (N - M): QT1 = QT - 1
114 QT2 = QT / 2: QT3 = QT2 - 1: KT = 0
116 REM *** UNIVERSAL BUTTERFLY ***
118 FOR J = 0 TO Q1 STEP QT: KT2 = KT + 1
120 FOR I = 0 TO QT3: J1 = I + J: K = J1 + QT2
122 CTEMP = (C(J1) + C(K) * KC(KT) - K6 * S(K) * KS(KT)) / SK1
124 STEMP = (S(J1) + K6 * C(K) * KS(KT) + S(K) * KC(KT)) / SK1
126 CTEMP2 = (C(J1) + C(K) * KC(KT2) - K6 * S(K) * KS(KT2)) / SK1
128 S(K) = (S(J1) + K6 * C(K) * KS(KT2) + S(K) * KC(KT2)) / SK1
130 C(K) = CTEMP2: C(J1) = CTEMP: S(J1) = STEMP
132 NEXT I
134 KT = KT + 2: NEXT J
136 NEXT M
140 ' ***  BIT REVERSAL FOR FINAL DATA ***
142 FOR I = 1 TO Q1: INDX = 0
144 FOR J = 0 TO N1
146 IF I AND 2 ^ J THEN INDX = INDX + 2 ^ (N1 - J)
148 NEXT J
150 IF INDX > I THEN SWAP C(I), C(INDX): SWAP S(I), S(INDX)
152 NEXT I
154 GOTO 200

    '   *** FORWARD FFT ***
160 K6 = -1: SK1 = 2
162 CLS : HDR$ = "FREQ   F(COS)       F(SIN)       "
164 HDR$ = HDR$ + "FREQ   F(COS)       F(SIN)": PRINT : PRINT
166 GOSUB 100
168 RETURN

    '   *** INVERSE TRANSFORM ***
170 SK1 = 1: K6 = 1: YSF = 64
172 CLS : HDR$ = "TIME    AMPLITUDE   NOT USED     "
174 HDR$ = HDR$ + "TIME   AMPLITUDE     NOT USED": PRINT : PRINT
176 GOSUB 100
178 RETURN

    ' ***   MODIFY SYSTEM PARAMETERS   ***
180 CLS
182 INPUT "PRESENT DATA GRAPHICALLY? (Y/N):"; A$
184 IF A$ = "Y" OR A$ = "y" THEN IOFLG = 1 ELSE IOFLG = -1
186 RETURN

    '   *****  OUTPUT DATA  *****
200 T9 = TIMER - T9
202 IF IOFLG = 1 THEN 250
206 ZSTP = 15
208 PRINT HDR$: PRINT : PRINT
210 FOR Z = 0 TO Q2 - 1
215 GOSUB 300
216 IF Z > ZSTP THEN 350 ' PRINT 1 SCREEN AT A TIME
220 NEXT Z
222 LOCATE 1, 1: PRINT : PRINT "TIME ="; T9
225 INPUT "C/R TO CONTINUE:"; A$
229 RETURN

250 '   *** PLOT OUTPUT ***
252 CLS : YPX = 0: IF K6 = -1 THEN 280
254 Y0 = 175
256 FOR I = 0 TO Q - 1
258 IF C(I) > YPX THEN YPX = C(I)
260 NEXT I
262 YSF = 100 / YPX
263 LINE (X0 + 10, Y0 - 100)-(X0, Y0 - 100)
264 LOCATE 6, 1: PRINT USING "###.##"; YPX
265 LINE (X0 - 1, 50)-(X0 - 1, 300)
266 LINE (X0, Y0)-(X0 + 500, Y0)
268 LINE (X0, Y0)-(X0, Y0)

270 FOR I = 0 TO Q - 1
272 YP = C(I)
274 IF K6 = -1 THEN YP = SQR(C(I) ^ 2 + S(I) ^ 2)
276 LINE -(X0 + XSF * I, Y0 - YSF * YP)
278 NEXT I
279 GOTO 222
280 ' ***   FIND Y SCALE FACTOR FOR FREQ DOMAIN PLOT   ***
281 Y0 = 300 ' SET Y AXIS ORIGIN
282 FOR I = 0 TO Q - 1 ' FIND LARGEST VALUE IN ARRAY
284 YP = SQR(C(I) ^ 2 + S(I) ^ 2): IF YP > YPX THEN YPX = YP
286 NEXT I
287 YSF = 200 / YPX ' SET SCALE FACTOR
288 LINE (X0 + 10, Y0 - 200)-(X0, Y0 - 200)
289 LOCATE 8, 1: PRINT USING "###.##"; YPX: GOTO 265

300 PRINT USING "###"; Z; : PRINT "   ";
310 PRINT USING "+##.#####"; C(Z); : PRINT "    ";
312 PRINT USING "+##.#####"; S(Z); : PRINT "      ";
320 PRINT USING "###"; Z + Q2; : PRINT "   ";
322 PRINT USING "+##.#####"; C(Z + Q2); : PRINT "    ";
324 PRINT USING "+##.#####"; S(Z + Q2)
330 RETURN

350 '   *** STOP WHEN SCREEN FULL ***
352 ZSTP = ZSTP + 16
354 PRINT : INPUT "C/R TO CONTINUE:"; A$
356 CLS : PRINT HDR$: PRINT : PRINT
358 GOTO 220

600 '   * SQUARE FUNCTION *
602 CLS : PRINT : PRINT
604 PRINT "PREPARING DATA INPUT - PLEASE WAIT!"
610 FOR I = 0 TO Q / 2 - 1
620 C(I) = -1: S(I) = 0
630 NEXT
640 FOR I = Q / 2 TO Q - 1
650 C(I) = 1: S(I) = 0
660 NEXT
680 GOSUB 160
690 RETURN

'      ***************************************
990 STOP: END

1000 '   ***************************************
1002 '   *           MODIFY SPECTRUM           *
1004 '   ***************************************
1040 CLS : RTFLG = 0
1042 IF K6 <> -1 THEN 1096
1050 PRINT SPC(30); "MODIFY SPECTRUM MENU": PRINT : PRINT
1060 PRINT SPC(5); "1 = TRUNCATE SPECTRUM": PRINT
1062 PRINT SPC(5); "2 = BUTTERWORTH RESPONSE": PRINT
1064 PRINT SPC(5); "3 = GAUSSIAN RESPONSE": PRINT
1066 PRINT SPC(5); "4 = CIRCUIT CONVOLUTION": PRINT
1067 PRINT SPC(5); "5 = INPUT CIRCUIT": PRINT
1068 PRINT SPC(5); "6 = EXIT": PRINT
1070 PRINT SPC(10); "MAKE SELECTION :";
1080 A$ = INKEY$: IF A$ = "" THEN 1080
1082 A = VAL(A$): ON A GOSUB 1100, 1200, 1300, 1400, 20000, 1990
1084 GOSUB 200
1088 IF RTFLG = 1 THEN RETURN
1090 GOTO 1040
1096 INPUT "MUST TRANSFORM SIGNAL BEFORE MODIFYING SPECTRUM"; A$
1098 RETURN

1100 '   * TRUNCATE SPECTRUM *
1102 CLS : PRINT : PRINT
1104 INPUT "ENTER CUTOFF FREQUENCY"; A$
1110 FC0 = VAL(A$): IF FC0 = 0 OR FC0 > Q3 THEN 1104
1130 FOR I = FC0 TO Q - FC0
1140 C(I) = 0: S(I) = 0
1150 NEXT I
1194 RTFLG = 1: RETURN

1200 '   * BUTTERWORTH RESPONSE *
1202 CLS : PRINT : PRINT
1204 PRINT "ENTER THE 3db CUTOFF HARMONIC NUMBER (1 TO "; Q3; ")";
1206 INPUT A$
1208 FC0 = VAL(A$): IF FC0 = 0 OR FC0 > Q3 THEN 1204
1210 NP = 7: REM NUMBER OF POLES = NP
1220 FOR I = 1 TO Q3
1222 ATTN = 1 / SQR(1 + (I / FC0) ^ (2 * NP))
1224 C(I) = ATTN * C(I): S(I) = ATTN * S(I)
1226 C(Q - I) = ATTN * C(Q - I): S(Q - I) = ATTN * S(Q - I)
1228 NEXT I
1230 ATTN = 1 / SQR(1 + (Q2 / FC0) ^ (2 * NP))
1234 C(Q2) = ATTN * C(Q2)
1294 RTFLG = 1: RETURN

1300 '   * GAUSSIAN RESPONSE *
1302 CLS : PRINT : PRINT
1304 PRINT "ENTER THE 3db CUTOFF HARMONIC NUMBER (1 TO "; Q3; ")";
1306 INPUT A$
1308 FC0 = VAL(A$): IF FC0 = 0 OR FC0 > Q3 THEN 1304
1320 FOR I = 1 TO Q3
1322 ATTN = 1 / SQR(EXP(.3 * ((I / FC0) ^ 2)))
1324 C(I) = ATTN * C(I): S(I) = ATTN * S(I)
1326 C(Q - I) = ATTN * C(Q - I): S(Q - I) = ATTN * S(Q - I)
1328 NEXT I
1330 ATTN = 1 / SQR(EXP(.3 * ((Q2 / FC0) ^ 2)))
1334 C(Q2) = ATTN * C(Q2): S(Q2) = ATTN * S(Q2)
1394 RTFLG = 1: RETURN

1400 '  * CONVOLVE WITH CIRCUIT XFER FUNCTION *
1402 CLS : PRINT : PRINT
1404 PRINT SPC(10); "CONVOLVING XFER FUNCTION WITH STEP FUNCTION"
1410 FOR I3 = 0 TO Q3
1412 GOSUB 10000 ' COMPUTE XFER FUNCTION
1424 CAT = (ATTNR * C(I3)) - (ATTNI * S(I3))' COMPLEX CONVOLUTION
1425 SAT = (ATTNI * C(I3)) + (ATTNR * S(I3))' IMAGINARY TERM
1426 C(I3) = CAT: S(I3) = SAT ' REAL FREQUENCIES
1427 C(Q - I3) = CAT: S(Q - I3) = -SAT' NEGATIVE FREQUENCIES
1428 NEXT I3
1430 I3 = Q2: GOSUB 10000
1434 C(Q2) = ATTNR * C(Q2): S(Q2) = 0
1494 RTFLG = 1: RETURN

1990 '   * EXIT MODIFY SPECTRUM ROUTINE *
1992 RTFLG = 1: RETURN

 '  ***********************************
 '  *       CALCULATE XFER FUNCTION       *
 '  ***********************************
10000 F = I3: FREQ = I3 ' FREQ = DATA POINT COUNTER
10010 GOSUB 11000 ' CALC IMPEDANCE MATRIX
10020 GOSUB 12000 ' SOLVE FOR CURRENTS
10030 ATTNR = Z(1, KB, KB + 1) * RTERM: ATTNI = Z(2, KB, KB + 1) * RTERM
10040  '  GOSUB 13000 ' PRINT OUT CURRENTS
10050 'FREQ = FREQ + 1 ' SET FOR NEXT DATA POINT
10060 'F(1, FREQ) = Z(1, KB, KB + 1): F(2, FREQ) = Z(2, KB, KB + 1)' SAVE
10070 'F = F0 * FSTEP ^ FREQ ' GET NEXT FREQUENCY
10080 'IF F <= FMX + .1 THEN 10010 ' JOB DONE?
10090 RETURN ' CLS : PLC = 22 ' CLEAR SCREEN FOR PRINTOUT
10100 F = 10 ^ FBOT ' GET BOTTOM FREQUENCY
10110 FOR I = 1 TO ((FTOP - FBOT) * DELF) + 1
10120 PRINT USING "#####.##_    "; F; ' PRINT FREQUENCY
10130 PRINT USING "##.####_   "; F(1, I) * RTERM; ' ? REAL COMPONENT
10140 J$ = "+j ": IF SGN(F(2, I)) < 0 THEN J$ = "-j "
10150 PRINT " "; J$;
10160 PRINT USING "#.####_    "; ABS(F(2, I) * RTERM); 'PRINT IMAGINARY
10170 MAG = SQR(F(1, I) ^ 2 + F(2, I) ^ 2) ' FIND MAGNITUDE
10180 IF MAG = 0 THEN PRINT "0.0000 /0.00": GOTO 10240
10190 PRINT USING "#.#####_ "; RTERM * MAG; : PRINT " /";
10200 IF F(1, I) = 0 AND F(2, I) >= 0 THEN BTA = PI / 2: GOTO 10230
10210 IF F(1, I) = 0 AND F(2, I) < 0 THEN BTA = -PI / 2: GOTO 10230
10220 BTA = ATN(F(2, I) / F(1, I)): IF F(1, I) < 0 THEN BTA = BTA + PI
10230 PRINT USING "###.##"; BTA * 180 / PI ' PRINT PHASE IN DEG.
10240 IF I < PLC THEN 10270 ' SCREEN FULL?
10250 PLC = PLC + 22: PRINT "                           (MORE)"
10260 INPUT "ENTER TO CONTINUE"; A$ ' WAIT FOR USER
10270 F = F0 * FSTEP ^ I' NEXT FREQ
10280 NEXT I ' PRINT NEXT COMPONENT
10290 INPUT "ENTER TO CONTINUE"; A$ ' WAIT
10300 RETURN ' WERE OUTA HERE

 '  ***********************************
 '  *          COMPUTE IMPEDANCE        *
 '  ***********************************
11000 CLS : WF = PI2 * F ' GET ANGULAR FREQUENCY
11010 FOR I = 1 TO KB ' FOR ALL MESHES
11020 Z(1, I, I) = COMP(1, I, I) ' GET RESISTOR VALUE
11030 IF COMP(3, I, I) = 0 THEN Z(2, I, I) = WF * COMP(2, I, I): GOTO 11060
11040 IF F = 0 THEN Z(2, I, I) = -1E+18: GOTO 11060
11050 Z(2, I, I) = WF * COMP(2, I, I) - 1 / (WF * COMP(3, I, I))
11060 FOR J = I + 1 TO KB ' GET MUTUAL IMPEDANCES
11070 Z(1, I, J) = -COMP(1, I, J) ' MUTUAL RESISTANCE
11080 IF COMP(3, I, J) = 0 THEN Z(2, I, J) = -WF * COMP(2, I, J): GOTO 11110
11090 IF F = 0 THEN Z(2, I, I) = -1E+18: GOTO 11110 ' FUDGE DC CAP
11100 Z(2, I, J) = -(WF * COMP(2, I, J) - 1 / (WF * COMP(3, I, J)))
11110 Z(2, J, I) = Z(2, I, J): Z(1, J, I) = Z(1, I, J)
11120 NEXT J ' NEXT MUTUAL IMPEDANCE
11130 NEXT I ' NEXT MESH
11140 Z(1, 1, KB + 1) = 1: Z(2, 1, KB + 1) = 0 ' DRIVE POINT VOLTAGE
11150 FOR I = 2 TO KB ' SET ALL OTHER MESH VOLTAGE SOURCES (ZERO)
11160 Z(1, I, KB + 1) = 0: Z(2, I, KB + 1) = 0 ' ALL ZERO
11170 NEXT I
11250 RETURN


 '  ***********************************
 '  *          SOLVE FOR CURRENTS       *
 '  ***********************************
12000 FOR J = 1 TO KB ' STEP THROUGH ALL DIAGONAL LOCATIONS
12200  '  GET A "1" COEFFICIENT ON THE DIAGONAL
12210 IF Z(2, J, J) = 0 THEN ZRE = 1 / Z(1, J, J): ZIM = 0: GOTO 12300
12220 IF Z(1, J, J) = 0 THEN ZRE = 0: ZIM = -1 / Z(2, J, J): GOTO 12300
12230 BTA = ATN(Z(2, J, J) / Z(1, J, J)): IF Z(1, J, J) < 0 THEN BTA = BTA + PI
12240 BTA = .5 * SIN(2 * BTA)
12250 ZRE = BTA / Z(2, J, J): ZIM = -BTA / Z(1, J, J)' INVERT Z(x,J,J)
12300 FOR K = J TO KB + 1
12310 Z1 = Z(1, J, K) * ZRE - (Z(2, J, K) * ZIM)
12315 Z(2, J, K) = Z(1, J, K) * ZIM + (Z(2, J, K) * ZRE): Z(1, J, K) = Z1
12320 NEXT K
12330 FOR I = 1 TO KB ' GET 0 IN THIS COL. FOR ALL OTHER EQNS.
12340 IF I = J THEN 12400
12350 XT = Z(1, I, J): YT = Z(2, I, J): IF XT = 0 AND YT = 0 THEN 12400
12360 FOR K = J + 1 TO KB + 1' DON'T BOTHER WITH "ZERO" POSITIONS
12370 Z(1, I, K) = Z(1, I, K) - (Z(1, J, K) * XT - (Z(2, J, K) * YT))
12380 Z(2, I, K) = Z(2, I, K) - (Z(1, J, K) * YT + (Z(2, J, K) * XT))
12390 NEXT K
12400 NEXT I
12410 NEXT J ' REPEAT FOR ALL DIAGONAL POSITIONS.
12420 RETURN
 '  ***********************************
 '  *          PRINTOUT CURRENTS        *
 '  ***********************************
13000 CLS : PRINT
13010 FOR I = 1 TO KB
13020 PRINT "I"; I; "=";
13030 PRINT USING "###.###"; Z(1, I, KB + 1);
13040 PRINT "+j";
13050 PRINT USING "###.###"; Z(2, I, KB + 1)
13060 NEXT I
13080 RETURN

 '  ***********************************
 '  *       INPUT CIRCUIT ELEMENTS     *
 '  ***********************************
20000 CLS : PRINT : PRINT "          INPUT CIRCUIT ELEMENTS"
20002 PRINT : GOSUB 21000 ' PRINT INSTRUCTIONS
20004 INPUT "ENTER NUMBER OF MESHES"; KB
20006 REDIM COMP(3, KB, KB), Z(2, KB, KB + 1)
20020 FOR I = 1 TO KB
20030 CLS : PRINT : PRINT "INPUT VALUES FOR MESH "; I: PRINT
20040 PRINT "ENTER MESH SELF RESISTANCE, INDUCTANCE, CAPACITANCE";
20050 INPUT COMP(1, I, I), COMP(2, I, I), COMP(3, I, I)
20060 FOR J = I + 1 TO KB
20070 PRINT "ENTER MESH ";
20080 PRINT USING "##_ "; I; J;
20090 PRINT " MUTUAL RESISTANCE, INDUCTANCE, CAPACITANCE";
20100 INPUT COMP(1, I, J), COMP(2, I, J), COMP(3, I, J)
20110 COMP(1, J, I) = COMP(1, I, J): COMP(2, J, I) = COMP(2, I, J)
20125 COMP(3, J, I) = COMP(3, I, J)
20130 NEXT J
20140 NEXT I
20150 INPUT "ENTER TERMINATION RESISTANCE"; RTERM
20160 RETURN

 '  ***************************************
 '  *               INSTRUCTIONS                 *
 '  ***************************************
21000 PRINT "1) LAYOUT CIRCUIT INTO MESHES"
21010 PRINT "2) MESH SELF IMPEDANCE = ";
21015 PRINT "SERIES SUMMATION OF ALL IMPEDANCES IN LOOP"
21020 PRINT "3) MESH MUTUAL IMPEDANCE = ";
21025 PRINT "COMMON IMPEDANCES BETWEEN LOOPS"
21030 INPUT "ENTER TO CONTINUE"; A$
21040 RETURN


